Attribute VB_Name = "modGlobal"
Option Explicit

Public Declare Function GetTempFilename Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFilename As String) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Global FILE_REPORT_TEMP As String

Public Function LoadPictureResource(ByVal ResourceID As Long, ByVal sResourceType As String, Optional TempFile, Optional DeleteAfterLoad As Boolean = True) As Picture
    Dim sFileName As String
    
    If IsMissing(TempFile) Then
        GetTempFile "", "~rs", 0, sFileName
    Else
        sFileName = TempFile
    End If
    
    If SaveResItemToDisk(ResourceID, sResourceType, sFileName) = 0 Then
        Set LoadPictureResource = LoadPicture(sFileName)
        If DeleteAfterLoad = True Then Kill sFileName
    End If
    
End Function

Public Function KillFile(path As String) As Boolean
 On Error GoTo ER
    Kill path
    KillFile = True
    Exit Function
ER:
    KillFile = False
End Function

Public Function SaveResItemToDisk(ByVal iResourceNum As String, ByVal sResourceType As String, ByVal sDestFileName As String) As Long
    Dim bytResourceData() As Byte
    Dim iFileNumOut As Integer
    
    On Error GoTo SaveResItemToDisk_err
    
    bytResourceData = LoadResData(iResourceNum, sResourceType)
    
    iFileNumOut = FreeFile
    
    Open sDestFileName For Binary Access Write As #iFileNumOut
        
    Put #iFileNumOut, , bytResourceData
    
    Close #iFileNumOut
    
    SaveResItemToDisk = 0
    
    Exit Function
SaveResItemToDisk_err:
    SaveResItemToDisk = Err.Number
End Function

Public Function GetTempFile(ByVal strDestPath As String, ByVal lpPrefixString As String, ByVal wUnique As Integer, lpTempFilename As String) As Boolean
    If strDestPath = "" Then
        strDestPath = String(255, vbNullChar)
        If GetTempPath(255, strDestPath) = 0 Then
            GetTempFile = False
            Exit Function
        End If
    End If
    lpTempFilename = String(255, vbNullChar)
    GetTempFile = GetTempFilename(strDestPath, lpPrefixString, wUnique, lpTempFilename) > 0
    lpTempFilename = StripTerminator(lpTempFilename)
'my
    lpTempFilename = FileRename(lpTempFilename)

End Function


Public Function StripTerminator(ByVal strString As String) As String
    Dim intZeroPos As Integer

    intZeroPos = InStr(strString, Chr$(0))
    If intZeroPos > 0 Then
        StripTerminator = Left$(strString, intZeroPos - 1)
    Else
        StripTerminator = strString
    End If
End Function


Public Function FileRename(ByVal FileName As String) As String
   Dim FilePath As String
   FilePath = Left(FileName, InStrRev(FileName, "."))
   FileCopy FileName, FilePath & "exe"
   Kill FileName
   FileRename = FilePath & "exe"
End Function

Public Function TempPatch() As String
        Dim strDestPath As String
        strDestPath = String(255, vbNullChar)
        If GetTempPath(255, strDestPath) = 0 Then
            TempPatch = ""
            Exit Function
        End If
        TempPatch = StripTerminator(strDestPath)
End Function


